Imports System.xml
''' <summary>
''' Defines an application's option.
''' </summary>
<Serializable()> Public NotInheritable Class ApplicationOption
    ''' <summary>
    ''' Name that identifies the option.
    ''' </summary>
    Public name As String
    ''' <summary>
    ''' Option's value.
    ''' </summary>
    Public value As String
    ''' <summary>
    ''' Initializes a new instance of the class ApplicationOption.
    ''' </summary>
    ''' <param name="n">Name that identifies the option.</param>
    ''' <param name="val">Option's value.</param>
    Sub New(ByVal n As String, ByVal val As String)
        name = n
        value = val
    End Sub

    Sub New()
    End Sub
End Class

''' <summary>
''' Defines a type of an application's option.
''' </summary>
Public Structure ApplicationOptionType
    ''' <summary>
    ''' Option's name.
    ''' </summary>
    Public name As String
    ''' <summary>
    ''' Values that indicates if the option is necessary. If the user tries to open an application with a not specified necessary option, he will get an error.
    ''' </summary>
    Public necessary As Boolean
    ''' <summary>
    ''' Default value of the option.
    ''' </summary>
    Public def As String
    ''' <summary>
    ''' Initializes a new instance of the class ApplicationOptionType.
    ''' </summary>
    ''' <param name="n">Option's name.</param>
    ''' <param name="o">Values that indicates if the option is necessary</param>
    ''' <param name="_def">Default value of the option.</param>
    ''' <remarks></remarks>
    Sub New(ByVal n As String, ByVal o As Boolean, Optional ByVal _def As String = "")
        name = n
        necessary = o
        def = _def
    End Sub
End Structure