Imports System.Windows.forms
''' <summary>
''' Represents an editor. For example, CodeEditor inherits this class. If you want to write a not-code editor (for example WYSIWYG), inherit this class.
''' </summary>
Public MustInherit Class Editor
    Inherits Control
    ''' <summary>
    ''' Called at the request to open a file in this editor.
    ''' </summary>
    ''' <param name="file">File's absolute path.</param>
    Public MustOverride Sub open(ByVal file As String)
    ''' <summary>
    ''' Called at the request to save a file opened in this editor.
    ''' </summary>
    ''' <param name="file">File's absolute path.</param>
    Public MustOverride Sub save(ByVal file As String)
    ''' <summary>
    ''' Called at a clic on Cut in the edit menu or in the toolbar.
    ''' </summary>
    Public MustOverride Sub cut()
    ''' <summary>
    ''' Called at a clic on Copy in the edit menu or in the toolbar.
    ''' </summary>
    Public MustOverride Sub copy()
    ''' <summary>
    ''' Called at a clic on Paste in the edit menu or in the toolbar.
    ''' </summary>
    Public MustOverride Sub paste()
    ''' <summary>
    ''' Called at a clic on Undo in the edit menu.
    ''' </summary>
    Public MustOverride Sub undo()
    ''' <summary>
    ''' Called at a clic on Redo in the edit menu.
    ''' </summary>
    Public MustOverride Sub redo()
    ''' <summary>
    ''' Called at a clic on Select All in the edit menu.
    ''' </summary>
    Public MustOverride Sub selectAll()
End Class
