Imports System.IO
''' <summary>
''' Contains informations about a source file of an application.
''' </summary>
Public Structure fileDetails
    ''' <summary>
    ''' File's path, relative to the application. To get the absolute path (application).filePath().
    ''' </summary>
    Public p As String
    ''' <summary>
    ''' String that identifies the action to do on this file in the application building.
    ''' </summary>
    Public buildAction As String
    ''' <summary>
    ''' Indicates if the file was opened the last time that the project has been closed.
    ''' </summary>
    Public opened As Boolean
    ''' <summary>
    ''' Returns an IO.FileInfo object associated with the file.
    ''' </summary>
    Public ReadOnly Property fInfo() As FileInfo
        Get
            Return New FileInfo(p)
        End Get
    End Property

    ''' <summary>
    ''' Initializes a new instance of the class fileDetails.
    ''' </summary>
    ''' <param name="_p">File's path, relative to the application.</param>
    ''' <param name="_genAz">String that identifies the action to do on this file in the application building.</param>
    '''<param name="_aperto">Indicates if the file was opened the last time that the project has been closed.</param>
    Sub New(ByVal _p As String, ByVal _genAz As String, ByVal _aperto As Boolean)
        p = _p
        buildAction = _genAz
        opened = _aperto
    End Sub
End Structure

