Imports System.Xml.Serialization
Imports System.IO

<Serializable()> Public Class Lang
    Public TranslatorName As String
    Public TranslatorLink As String
    Public formsTexts As New List(Of formTexts)
    Public guiMessages As New List(Of guiMessage)
    Public sharedControlTexts As New List(Of controlText)

#Region "File loader"
    Public Shared Function load(ByVal f As String) As Lang
        Dim xs As New XmlSerializer(GetType(Lang))
        Dim sr As New StreamReader(f)
        Return CType(xs.Deserialize(sr), Lang)
    End Function

    ''' <summary>
    ''' Unused in the software; only for testing.
    ''' </summary>
    Public Sub save(ByVal f As String)
        Dim xs As New XmlSerializer(GetType(Lang))
        Dim sw As New StreamWriter(f)
        xs.Serialize(sw, Me)
        sw.Close()
    End Sub
#End Region

#Region "textGetter"
    Private Function getForm(ByVal n As String) As formTexts
        Dim foundFrmTexts As New List(Of formTexts)
        For Each frmTexts As formTexts In formsTexts
            If frmTexts.formName = n Then
                foundFrmTexts.Add(frmTexts)
            End If
        Next
        If foundFrmTexts.Count = 0 Then
            Throw New langException(currLang, langErrType.FormNotFound, n)
        ElseIf foundFrmTexts.Count > 1 Then
            Throw New langException(currLang, langErrType.FormConflict, n)
        Else
            Return foundFrmTexts(0)
        End If
    End Function

    Public Function getFormTitle(ByVal n As String) As String
        Return getForm(n).formTitle
    End Function

    Public Function getControlText(ByVal frm As String, ByVal n As String) As String
        Dim frmTxt As formTexts = getForm(frm)
        Dim foundControlTexts As New List(Of controlText)
        For Each i As controlText In frmTxt.controlsTexts
            If i.name = n Then
                foundControlTexts.Add(i)
            End If
        Next
        For Each i As controlText In sharedControlTexts
            If i.name = n Then
                foundControlTexts.Add(i)
            End If
        Next
        If foundControlTexts.Count = 0 Then
            Throw New langException(currLang, langErrType.ControlNotFound, n)
        ElseIf foundControlTexts.Count > 1 Then
            Throw New langException(currLang, langErrType.ControlConflict, n)
        Else
            Return foundControlTexts(0).text
        End If
    End Function

    Public Function getMenuData(ByVal frm As String, ByVal n As String) As menuText
        Dim frmTxt As formTexts = getForm(frm)
        Dim foundMenuTexts As New List(Of menuText)
        For Each i As menuText In frmTxt.menusTexts
            If i.name = n.Replace("_", "") Then
                foundMenuTexts.Add(i)
            End If
        Next
        If foundMenuTexts.Count = 0 Then
            Throw New langException(currLang, langErrType.MenuNotFound, n)
        ElseIf foundMenuTexts.Count > 1 Then
            Throw New langException(currLang, langErrType.MenuConflict, n)
        Else
            Return foundMenuTexts(0)
        End If
    End Function
#End Region
End Class
