Public Class langException
    Inherits Exception
    Dim lng As Lang
    Public errorType As langErrType
    Dim itemName As String

    Sub New(ByVal l As Lang, ByVal err As langErrType, ByVal objName As String)
        lng = l
        errorType = err
        itemName = objName
    End Sub

    Public Sub showMsg()
        Dim msg As String = ""
        Select Case errorType
            Case langErrType.FormNotFound
                msg = "No form labels defined for the form " + itemName + " in the current language file."
            Case langErrType.FormConflict
                msg = "Conflict between more than one form labels defined for the form " + itemName + " in the current language file."
            Case langErrType.ControlNotFound
                msg = "No control text defined for the control " + itemName + " in the current language file."
            Case langErrType.ControlConflict
                msg = "Conflict between more than one text defined for the control " + itemName + " in the current language file."
            Case langErrType.MenuNotFound
                msg = "No control text defined for the menu " + itemName + " in the current language file."
            Case langErrType.MenuConflict
                msg = "Conflict between more than one text defined for the menu " + itemName + " in the current language file."
            Case langErrType.MessageNotFound
                msg = "No text defined for the message " + itemName + " in the current language file."
            Case langErrType.MessageConflict
                msg = "Conflict between more than one text defined for the message " + itemName + " in the current language file."
        End Select
        msg &= Environment.NewLine & "If you edited the language file try to re-download it. If the error persists contact the translator: " & lng.TranslatorName & ", " & lng.TranslatorLink
        MsgBox(msg, MsgBoxStyle.Critical, "Language parsing error")
    End Sub
End Class

Public Enum langErrType
    FormNotFound
    FormConflict
    ControlNotFound
    ControlConflict
    MenuNotFound
    MenuConflict
    MessageNotFound
    MessageConflict
End Enum
