Imports AddOnsLib
Imports LangLib
Imports System.Reflection

Public Class AddonManager
    Private t As Type()

    Sub New()
        t = loadTypes()
    End Sub

    Private Function loadTypes() As Type()
        Dim l As New List(Of Type)
        For Each d As String In My.Computer.FileSystem.GetDirectories(Application.StartupPath & "\Addons\")
            Dim n As String = New IO.DirectoryInfo(d).Name
            Dim f As String = d & "\" & n & ".dll"
            If My.Computer.FileSystem.FileExists(f) Then
                Dim a As Assembly = Assembly.LoadFrom(f)
                l.AddRange(a.GetTypes())
            Else
                MsgBox(getMsg("addonDirError", n), MsgBoxStyle.Critical)
            End If
        Next
        Return l.ToArray()
    End Function

    Public Function getLanguages() As Language()
        Dim l As New List(Of Language)
        For Each i As Type In t
            If i.BaseType Is GetType(Language) Then
                l.Add(CType(Activator.CreateInstance(i), Language))
            End If
        Next
        Return l.ToArray()
    End Function

    Public Function getAppTypes() As ApplicationType()
        Dim l As New List(Of ApplicationType)
        For Each i As Type In t
            If i.BaseType.BaseType Is GetType(ApplicationType) Then
                l.Add(CType(Activator.CreateInstance(i), ApplicationType))
            End If
        Next
        Return l.ToArray()
    End Function

    Public Function getLanguage(ByVal name As String) As Language
        Dim l As New List(Of Language)
        For Each i As Language In getLanguages()
            If i.name = name Then
                l.Add(i)
            End If
        Next
        If l.Count = 1 Then
            Return l(0)
        Else
            Throw New ArgumentException(getMsg("languageNotFound"))
        End If
    End Function

    Public Function getAppType(ByVal name As String) As ApplicationType
        Dim l As New List(Of ApplicationType)
        For Each i As ApplicationType In getAppTypes()
            If i.name = name Then
                l.Add(i)
            End If
        Next
        If l.Count = 1 Then
            Return l(0)
        Else
            Throw New ArgumentException(getMsg("appTypeNotFound", name))
        End If
    End Function

    Public Function exists(ByVal t As itemType, ByVal n As String) As Boolean
        Try
            If t = itemType.Lnaguage Then
                getLanguage(n)
            ElseIf t = itemType.AppType Then
                getAppType(n)
            End If
            Return True
        Catch ex As Exception
            Return False
        End Try
    End Function
End Class

Public Enum itemType
    Lnaguage
    AppType
End Enum