Imports AddOnsLib
Imports LangLib

Public Class MainForm

    Dim currProject As Project
    Public Shared addons As AddonManager

    Private Sub MainForm_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
        LangUtil.loadFiles(Application.StartupPath & "\lang\" & My.Settings.Lang & ".xml", Application.StartupPath() & "\lang\_def.xml")
        applyLang(Me, TabsContextMenu)
        Text = My.Application.Info.Title & " " & My.Application.Info.Version.Major & "." & My.Application.Info.Version.Minor & " beta"
        Schede.TabPages.Clear()
        StartPage.Tag = New tabInfo(tabType.Home, "", Nothing)
        Schede.TabPages.Add(StartPage)
        UpdateTabs()
        UpdateRecentProjects()
        addons = New AddonManager()
        StatusText.Text = getMsg("statusReady")
    End Sub

#Region "Menus and toolbars"

    Private Sub exitprogram_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles exitprogram.Click
        Application.Exit()
    End Sub

    Private Sub about_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles about.Click, about_.Click
        MsgBox("UniversalIDE, open source multi-language developing environment for windows, version 0.2 beta", MsgBoxStyle.Information)
    End Sub

    Private Sub closetab_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles closetab_.Click, closetab.Click
        tabClose(Schede.SelectedTab)
    End Sub

    Private Sub closeexcept_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles closeexcept_.Click, closeexcept.Click
        Dim cs As TabPage = Schede.SelectedTab
        For Each s As TabPage In Schede.TabPages
            tabClose(s)
        Next
        Schede.TabPages.Add(cs)
    End Sub

    Private Sub openstartpage_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles openstartpage_.Click, openstartpage.Click
        If Schede.Contains(StartPage) = False Then
            Schede.TabPages.Add(StartPage)
        End If
        Schede.SelectedTab = StartPage
        UpdateTabs()
        UpdateRecentProjects()
    End Sub

    Private Sub openrecent_DropDownItemClicked(ByVal sender As System.Object, ByVal e As System.Windows.Forms.ToolStripItemClickedEventArgs) Handles openrecent.DropDownItemClicked
        OpenPrj(e.ClickedItem.Text)
    End Sub

    Private Sub savecurrent_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles savecurrent.Click, savecurrent_.Click
        saveTab(Schede.SelectedIndex)
    End Sub

    Private Sub saveall_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles saveall.Click
        For i As Integer = 0 To Schede.TabPages.Count - 1
            If Not Object.Equals(Schede.TabPages(i), StartPage) Then
                saveTab(i)
            End If
        Next
    End Sub

    Private Sub cut_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles cut_.Click, cut.Click
        Try
            CType(Schede.SelectedTab.Controls(0), Editor).cut()
        Catch ex As Exception
        End Try
    End Sub

    Private Sub copy_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles copy_.Click, copy.Click
        Try
            CType(Schede.SelectedTab.Controls(0), Editor).copy()
        Catch ex As Exception
        End Try
    End Sub

    Private Sub paste_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles paste_.Click, paste.Click
        Try
            CType(Schede.SelectedTab.Controls(0), Editor).paste()
        Catch ex As Exception
        End Try
    End Sub

    Private Sub undo_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles undo.Click
        Try
            CType(Schede.SelectedTab.Controls(0), Editor).undo()
        Catch ex As Exception
        End Try
    End Sub

    Private Sub redo_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles redo.Click
        Try
            CType(Schede.SelectedTab.Controls(0), Editor).redo()
        Catch ex As Exception
        End Try
    End Sub

    Private Sub selectall_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles selectall.Click
        Try
            CType(Schede.SelectedTab.Controls(0), Editor).selectAll()
        Catch ex As Exception
        End Try
    End Sub

    Private Sub newapplication_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles newapplication.Click, newapplication_.Click
        newapp()
    End Sub

    Private Sub newfile_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles newfile.Click, newfile_.Click
        Try
            Dim fn As String = InputBox(getMsg("name"))
            My.Computer.FileSystem.WriteAllText(currPath() & fn, "", False)
            Dim n As TreeNode = FileManager.SelectedNode
            If n.ImageIndex <> 1 Then
                Do
                    n = n.Parent
                    If n.ImageIndex = 1 Then
                        Exit Do
                    End If
                Loop
            End If
            Dim fRelPath As String = currPath(True, False) & fn
            currProject.applications(n.Index).AppFiles.Add(New fileDetails(fRelPath, "", False))
        Catch ex As Exception
            MsgBox(ex.Message, MsgBoxStyle.Critical)
        End Try
        RefreshFiles()
    End Sub

    Private Sub newdir_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles newdir.Click, newdir_.Click
        Dim dn As String = InputBox(getMsg("name"))
        My.Computer.FileSystem.CreateDirectory(currPath() & dn)
        RefreshFiles()
    End Sub

    Private Sub buildrun_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles buildrun_.Click, buildrun.Click
        build()
        run()
    End Sub

    Private Sub onlybuild_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles onlybuild.Click
        build()
    End Sub

    Private Sub onlyrun_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles onlyrun.Click
        run()
    End Sub

    Private Sub options_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles options.Click
        MsgBox(getMsg("notImplemented"), MsgBoxStyle.Information)
    End Sub

    Private Sub addonmanagment_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles addonmanagment.Click
        Process.Start(Application.StartupPath & "\Addons")
    End Sub
#End Region

#Region "Tabs"
    Public Function getTabInfo(ByVal tab As TabPage) As tabInfo
        Return CType(tab.Tag, tabInfo)
    End Function

    Private Sub MainSplitContainer_SplitterMoved(ByVal sender As System.Object, ByVal e As System.Windows.Forms.SplitterEventArgs) Handles MainSplitContainer.SplitterMoved
        Schede.Refresh()
    End Sub

    Sub UpdateTabs()
        window.DropDownItems.Clear()
        TabsContextMenu.Items.Clear()
        window.DropDownItems.Add(closetab)
        window.DropDownItems.Add(closeexcept)
        window.DropDownItems.Add(openstartpage)
        window.DropDownItems.Add(ToolStripSeparator8)
        TabsContextMenu.Items.Add(closetab_)
        TabsContextMenu.Items.Add(closeexcept_)
        TabsContextMenu.Items.Add(openstartpage_)
        TabsContextMenu.Items.Add(ToolStripSeparator9)
        For i As Integer = 0 To Schede.TabPages.Count - 1
            Dim scheda As TabPage = Schede.TabPages.Item(i)
            Dim e As New EventHandler(AddressOf tabClick)
            window.DropDownItems.Add(scheda.Text, Nothing, e)
            TabsContextMenu.Items.Add(scheda.Text, Nothing, e)
            window.DropDownItems.Item(i + 3).Tag = i
            TabsContextMenu.Items.Item(i + 3).Tag = i
        Next
    End Sub

    Private Sub tabClick(ByVal sender As System.Object, ByVal e As System.EventArgs)
        Schede.SelectedIndex = CType(sender, ToolStripMenuItem).Tag
    End Sub

    Function tabId(ByVal file As String) As Integer
        For i As Integer = 0 To Schede.TabPages.Count - 1
            If getTabInfo(Schede.TabPages(i)).f = file Then
                Return i
            End If
        Next
        Return -1
    End Function

    Sub tabClose(ByVal s As TabPage)
        Dim tInfo As tabInfo = getTabInfo(s)
        If tInfo.t = tabType.Prj Then
            currProject.detailsTabOpened = False
        ElseIf tInfo.t = tabType.File Then
            currProject.applications(tInfo.appId).setFileOpen(tInfo.f, False)
        End If
        Schede.TabPages.Remove(s)
    End Sub

    Sub openFile(ByVal file As String, ByVal appId As Integer)
        Dim absFile As String = ""
        If file = currProject.File Then
            absFile = file
        Else
            absFile = currProject.dir() & "\src\" & currProject.applications(appId).Name & "\" & file
        End If
        Dim id As Integer = tabId(absFile)
        If id = -1 Then
            Dim fi As New IO.FileInfo(absFile)
            Dim c As Control = Nothing
            Dim t As tabType
            If fi.Extension = ".uidp" Then
                t = tabType.Prj
                c = New ProjectDetails(currProject)
                applylangControl(Me.Name, c)
                currProject.detailsTabOpened = True
            Else
                t = tabType.File
                c = addons.getAppType(currProject.applications(appId).AppType).getDefaultEditor(fi.Extension, addons.getLanguages)
                If Object.Equals(c, Nothing) Then
                    MsgBox(getMsg("noAssociatedEditor"), MsgBoxStyle.Critical)
                    Exit Sub
                Else
                    CType(c, Editor).open(absFile)
                End If
                currProject.applications(appId).setFileOpen(absFile)
            End If
            Dim p As New TabPage(fi.Name)
            c.Dock = DockStyle.Fill
            p.Controls.Add(c)
            p.Tag = New tabInfo(t, absFile, appId)
            Schede.TabPages.Add(p)
            Schede.SelectedTab = p
        Else
            Schede.SelectedIndex = id
        End If
    End Sub

    Sub saveTab(ByVal id As Integer)
        saveProject()
        Dim f As String = getTabInfo(Schede.TabPages(id)).f
        If f <> Nothing And f <> currProject.File Then
            Dim c As Control = Schede.TabPages(id).Controls(0)
            Try
                CType(c, Editor).save(f)
            Catch ex As Exception
                MsgBox(ex.Message)
            End Try
        End If
    End Sub
#End Region

#Region "FileManager"

    Public Sub RefreshFiles()
        FileManager.Nodes.Clear()
        FileManager.Nodes.Add(currProject.name, currProject.name, 0)
        For Each app As ProjectApplication In currProject.applications
            Dim n As New TreeNode(app.Name, 1, 1)
            n.Tag = app.AppType
            FileManager.Nodes(0).Nodes.Add(n)
            Dim ok As Boolean = True
            If app.dir = "" Then
                n.Nodes.Add("", "Cannot find directory", 2)
                ok = False
            End If
            If Not addons.exists(itemType.AppType, app.AppType) Then
                n.Nodes.Add("", "Cannot find add-on", 2)
                ok = False
            End If
            If ok Then
                addDir(app.dir, n, app.Name)
            End If
        Next
        FileManager.Nodes(0).Expand()
    End Sub

    Sub addDir(ByVal Cartella As String, ByVal n As TreeNode, ByVal app As String)
        For Each corrdir As String In My.Computer.FileSystem.GetDirectories(Cartella)
            n.Nodes.Add(corrdir, New IO.DirectoryInfo(corrdir).Name, 3)
            addDir(corrdir, n.LastNode, app)
        Next
        For Each file As String In My.Computer.FileSystem.GetFiles(Cartella)
            Dim nd As New TreeNode(New IO.FileInfo(file).Name, 4, 4)
            nd.Tag = file.Remove(0, currProject.dir().Length + ("\src\" & app & "\").Length)
            n.Nodes.Add(nd)
        Next
    End Sub

    Private Sub FileManager_AfterSelect(ByVal sender As System.Object, ByVal e As System.Windows.Forms.TreeViewEventArgs) Handles FileManager.AfterSelect
        e.Node.SelectedImageIndex = e.Node.ImageIndex
    End Sub

    Private Sub FileManager_NodeMouseDoubleClick(ByVal sender As System.Object, ByVal e As System.Windows.Forms.TreeNodeMouseClickEventArgs) Handles FileManager.NodeMouseDoubleClick
        If Object.Equals(e.Node.Parent, Nothing) Then
            openProjectDetails()
        ElseIf Object.Equals(e.Node.Parent.Parent, Nothing) Then
            Try
                addons.getAppType(currProject.applications(e.Node.Index).AppType).editOptions(currProject.applications(e.Node.Index))
            Catch ex As Exception
                MsgBox(ex.Message, MsgBoxStyle.Critical)
                RefreshFiles()
            End Try
        ElseIf e.Node.ImageIndex <> 3 Then
            Dim n As TreeNode = e.Node
            Do
                n = n.Parent
                If n.ImageIndex = 1 Then
                    Exit Do
                End If
            Loop
            openFile(e.Node.Tag, n.Index)
        End If
    End Sub

    Function currPath(Optional ByVal rel As Boolean = False, Optional ByVal includeApp As Boolean = True) As String
        If Not rel And Not includeApp Then Throw New ArgumentException()
        Dim n As TreeNode = FileManager.SelectedNode
        Dim appRoot As String = currProject.dir & "\src\"
        If rel Then
            appRoot = ""
        End If
        If Object.Equals(n, Nothing) Then
            Throw New ArgumentException(getMsg("noSelectedDir"))
        End If
        If n.ImageIndex < 3 Then
            If n.ImageIndex = 1 Then
                If includeApp Then
                    Return appRoot & n.Text & "\"
                Else
                    Return ""
                End If
            Else
                Throw New ArgumentException(getMsg("noDirAccessible"))
            End If
        Else
            If n.ImageIndex <> 3 Then
                n = n.Parent
            End If
            Dim p As String = ""
            Do
                p = n.Text & "\" & p
                n = n.Parent
            Loop Until n.ImageIndex = 1
            p = appRoot & n.Text & "\" & p
            If Not includeApp Then
                p = p.Remove(0, n.Text.Length + 1)
            End If
            Return p
        End If
    End Function
#End Region

#Region "Home"
    Private Sub newproject_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles newproject.Click, newproject_.Click, btnHomeNew.Click
        Dim np As New NewPrjDialog
        If np.ShowDialog() = Windows.Forms.DialogResult.OK Then
            OpenPrj(np.f)
        End If
    End Sub

    Private Sub HomeRecent_SelectedIndexChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles HomeRecent.SelectedIndexChanged
        OpenPrj(HomeRecent.SelectedItem)
    End Sub

    Private Sub openproject_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles openproject.Click, openproject_.Click, btnHomeOpen.Click
        If OpenDialog.ShowDialog() = Windows.Forms.DialogResult.OK Then
            OpenPrj(OpenDialog.FileName)
        End If
    End Sub
#End Region

#Region "Projects"

    Sub OpenPrj(ByVal file As String)
        Dim ok As Boolean = False
        If Object.Equals(currProject, Nothing) Then
            ok = True
        Else
            ok = (MsgBox(getMsg("closeProjectAlert"), MsgBoxStyle.YesNo) = MsgBoxResult.Yes)
        End If
        If ok Then
            If My.Computer.FileSystem.FileExists(file) Then
                StatusText.Text = getMsg("openingProject", file)
                Try
                    currProject = Project.Open(file)
                Catch ex As Exception
                    MsgBox(ex.Message, MsgBoxStyle.Critical)
                    StatusText.Text = getMsg("statusReady")
                    Exit Sub
                End Try
                RefreshFiles()
                For Each s As TabPage In Schede.TabPages
                    If s.Text <> StartPage.Text Then
                        Schede.TabPages.Remove(s)
                    End If
                Next
                If My.Settings.RecentProjects.Contains(file) Then
                    My.Settings.RecentProjects.Remove(file)
                End If
                My.Settings.RecentProjects.Add(file)
                UpdateRecentProjects()
                If currProject.detailsTabOpened Then
                    openProjectDetails()
                End If
                For appId As Integer = 0 To currProject.applications.Count - 1
                    For Each f As fileDetails In currProject.applications(appId).AppFiles
                        If f.opened Then
                            openFile(f.p, appId)
                        End If
                    Next
                Next
                StatusText.Text = getMsg("statusReady")
            Else
                MsgBox(getMsg("cannotFindFile", file), MsgBoxStyle.Critical)
                If My.Settings.RecentProjects.Contains(file) Then
                    If MsgBox(getMsg("removeFromRecent"), MsgBoxStyle.YesNo) = MsgBoxResult.Yes Then
                        My.Settings.RecentProjects.Remove(file)
                        UpdateRecentProjects()
                    End If
                End If
            End If
        End If
    End Sub

    Sub saveProject()
        currProject.Save(Schede)
    End Sub

    Sub UpdateRecentProjects()
        HomeRecent.Items.Clear()
        openrecent.DropDownItems.Clear()
        For i As Integer = My.Settings.RecentProjects.Count - 1 To 0 Step -1
            HomeRecent.Items.Add(My.Settings.RecentProjects(i))
            If Math.Abs(-i) >= My.Settings.RecentProjects.Count - 5 Then
                openrecent.DropDownItems.Add(My.Settings.RecentProjects(i))
            End If
        Next
    End Sub

    Sub openProjectDetails()
        openFile(currProject.File, Nothing)
    End Sub

    Sub newapp()
        Dim f As New NewAppDialog
        If f.ShowDialog() = Windows.Forms.DialogResult.OK Then
            'If MsgBox(getMsg("needSave"), MsgBoxStyle.YesNo) = MsgBoxResult.Yes Then
            currProject.applications.Add(New ProjectApplication(f.appName.Text, addons.getAppTypes()(f.appType.SelectedIndex), currProject.dir()))
            saveProject()
            RefreshFiles()
            'End If
        End If
    End Sub
#End Region

#Region "Debug"
    Sub build()
        Dim log As String = ""
        For Each app As ProjectApplication In currProject.applications
            Dim d As String = currProject.dir & "\bin\" & app.Name
            If Not My.Computer.FileSystem.DirectoryExists(d) Then
                My.Computer.FileSystem.CreateDirectory(d)
            End If
            Try
                Dim o As BuildingOutput = addons.getAppType(app.AppType).build(app, d)
                log &= app.Name & Environment.NewLine & o.log.ToString & Environment.NewLine & Environment.NewLine
            Catch ex As Exception
                MsgBox(ex.Message, MsgBoxStyle.Critical)
            End Try
        Next
        My.Computer.FileSystem.WriteAllText(currProject.dir & "\LastBuildLog.txt", log, False)
        Process.Start(currProject.dir & "\LastBuildLog.txt")
    End Sub

    Sub run()
        For Each app As ProjectApplication In currProject.applications
            Dim d As String = ""
            Dim t As ApplicationType = addons.getAppType(app.AppType)
            If t.isParsed Then
                d = currProject.dir & "\src\" & app.Name
            Else
                d = currProject.dir & "\bin\" & app.Name
            End If
            t.run(d)
        Next
    End Sub
#End Region
End Class
