Imports AddOnsLib
Imports LangLib

Public Class ProjectDetails
    Dim proj As Project

    Sub New(ByVal p As Project)
        InitializeComponent()
        proj = p
    End Sub

    Private Sub ProjectDetails_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
        RefreshApps()
        appNameField.Text = getMsg("appNameField")
        appTypeField.Text = getMsg("appTypeField")
    End Sub

    Sub RefreshApps()
        Applications.Items.Clear()
        For Each app As ProjectApplication In proj.applications
            Dim col() As String = {app.Name, app.AppType}
            Applications.Items.Add(New ListViewItem(col))
        Next
    End Sub

    Private Sub btnAdd_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnAdd.Click
        MainForm.newapp()
    End Sub

    Private Sub btnOptions_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnOptions.Click
        Try
            Dim a As ProjectApplication = proj.applications(Applications.SelectedIndices(0))
            MainForm.addons.getAppType(a.AppType).editOptions(a)
        Catch ex As Exception
            MsgBox(ex.Message, MsgBoxStyle.Critical)
        End Try
    End Sub

    Private Sub btnDelete_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnDelete.Click
        If Applications.SelectedIndices.Count <> 0 Then
            Dim i As Integer = Applications.SelectedIndices(0)
            Dim a As String = proj.applications(i).Name
            Dim d As String = proj.applications(i).dir
            If MsgBox(getMsg("deleteApp", a), MsgBoxStyle.YesNo) = MsgBoxResult.Yes Then
                proj.applications.RemoveAt(Applications.SelectedIndices(0))
                If My.Computer.FileSystem.DirectoryExists(d) Then
                    If MsgBox(getMsg("deleteAlsoAppDir"), MsgBoxStyle.YesNo) = MsgBoxResult.Yes Then
                        My.Computer.FileSystem.DeleteDirectory(d, FileIO.DeleteDirectoryOption.DeleteAllContents)
                    End If
                End If
                CType(Me.ParentForm, MainForm).RefreshFiles()
                proj.Save()
            End If
        Else
            MsgBox(getMsg("noAppSelected"), MsgBoxStyle.Critical)
        End If
        RefreshApps()
    End Sub
End Class
